// Defines

#define MMC_KERNEL_SECTORSIZE 		512

#define MMC_MAX_BUSY_LOOPS			50000
#define MMC_MAX_TOKEN_LOOPS			50000


// MMC Commands
#define MMC_GO_IDLE_STATE			0
#define MMC_SEND_OP_COND			1
#define MMC_SEND_IF_COND			8
#define MMC_SEND_CSD				9
#define MMC_SEND_CID				10 
#define MMC_STOP_TRANSMISSION		12
#define MMC_SEND_STATUS				13
#define MMC_READ_SINGLE_BLOCK		17
#define MMC_READ_MULTIPLE_BLOCK		18
#define MMC_SET_BLOCK_COUNT			23
#define MMC_WRITE_BLOCK				24
#define MMC_WRITE_MULTIPLE_BLOCK	25
#define MMC_APP_CMD					55
#define MMC_READ_OCR				58

// Application Commands
#define MMC_SD_SEND_OP_COND			41

// Response sizes
#define MMC_CSD_SIZE				16
#define MMC_CID_SIZE				16
#define MMC_OCR_SIZE				4
#define MMC_IF_COND_SIZE			4

// R1 Flags
#define MMC_R1_IN_IDLE_STATE		0x01 
#define MMC_R1_ERASE_STATE			0x02
#define MMC_R1_ILLEGAL_COMMAND		0x04
#define MMC_R1_COM_CRC_ERROR		0x08
#define MMC_R1_ERASE_SEQUENCE_ERROR	0x10
#define MMC_R1_ADDRESS_ERROR		0x20
#define MMC_R1_PARAMETER_ERROR		0x40

// MMC Tokens
#define MMC_START_BLOCK				0xFE
#define MMC_START_BLOCK_2			0xFC
#define MMC_STOP_TRAN				0xFD
#define MMC_ERROR_MASK				0x1F
#define MMC_DATA_ACCEPTED			0x05
#define MMC_DATA_CRC_ERROR			0x0B
#define MMC_DATA_WRITE_ERROR		0x0D

// IF_COND
#define MMC_IF_COND_CHECK_PATERN	0xAA
#define MMC_IF_COND_VHS				0x01			// 2.7 - 3.6 V
#define MMC_IF_COND_MAGIC			((MMC_IF_COND_VHS << 8) | MMC_IF_COND_CHECK_PATERN)

// OP_COND
#define MMC_OP_COND_HCS				(1 << 30)
#define MMC_MAX_OP_COND_LOOPS		10000
