// Includes

#include "mmc.h"

// Defines

#define 	MMC_SPI_SLOW			0
#define 	MMC_SPI_FAST			1

#if 		(MMC_ALT_IO == 1)
 #define 	MMC_SO					31		// OG31 Connected to MMC DI
 #define 	MMC_SI					31		// IG31 Connected to MMC DO
 #define 	MMC_CLK					30		// OG30 
 #define 	MMC_CS					1		// OG1
 #define 	MMC_DETECT_PIN			1		// IG1
#else
 #define 	MMC_SO					4		// OG4 Connected to MMC DI
 #define 	MMC_SI					1		// IG1 Connected to MMC DO
 #define 	MMC_CLK					1		// OG1
 #define 	MMC_CS					3		// OG3
 #define 	MMC_DETECT_PIN			4		// IG4
#endif

#define 	MMC_SI_PIN				(*(volatile unsigned int *)R_PORT_G_DATA & (1 << MMC_SI))
#define 	MMC_SO_LOW				*(volatile unsigned int *)R_PORT_G_DATA =(port_g_data_shadow &= ~(1 << MMC_SO))
#define 	MMC_SO_HIGH				*(volatile unsigned int *)R_PORT_G_DATA =(port_g_data_shadow |= (1 << MMC_SO))
#define 	MMC_CLK_LOW				*(volatile unsigned int *)R_PORT_G_DATA =(port_g_data_shadow &= ~(1 << MMC_CLK))
#define 	MMC_CLK_HIGH			*(volatile unsigned int *)R_PORT_G_DATA =(port_g_data_shadow |= (1 << MMC_CLK))
#define		MMC_SELECT				*(volatile unsigned int *)R_PORT_G_DATA =(port_g_data_shadow &= ~(1 << MMC_CS))
#define 	MMC_DESELECT			*(volatile unsigned int *)R_PORT_G_DATA =(port_g_data_shadow |= (1 << MMC_CS))

#if 		(MMC_INSERT_DETECT == 0)
 #define 	MMC_CARD_PRESENT		1
#else
 #define 	MMC_CARD_PRESENT		((*(volatile unsigned int *)R_PORT_G_DATA & (1 << MMC_DETECT_PIN)) == 0)
#endif

#if			(MMC_LED_ENABLE == 0)
 #define 	MMC_LED_SETUP			mmc_led = 0
 #define 	MMC_LED_ON	
 #define 	MMC_LED_OFF	
 #define 	MMC_LED_TOGGLE	
#else
 #define 	MMC_LED_PIN				0		// PA0
 #define 	MMC_LED_SETUP			REG_SHADOW_SET(R_PORT_PA_DIR, port_pa_dir_shadow, MMC_LED_PIN, 1);
 #define 	MMC_LED_ON				REG_SHADOW_SET(R_PORT_PA_DATA, port_pa_data_shadow, MMC_LED_PIN, (mmc_led = 1))
 #define 	MMC_LED_OFF				REG_SHADOW_SET(R_PORT_PA_DATA, port_pa_data_shadow, MMC_LED_PIN, (mmc_led = 0))
 #define 	MMC_LED_TOGGLE			REG_SHADOW_SET(R_PORT_PA_DATA, port_pa_data_shadow, MMC_LED_PIN, (mmc_led ^= 1))
#endif


// Prototypes

void mmc_led_on(void);
void mmc_led_off(void);
void mmc_spi_setup(void);
void mmc_spi_write_n(void *buffer, unsigned short len);
void mmc_spi_write(unsigned char c);
void mmc_spi_read_n(void *buffer, unsigned short len);
unsigned char mmc_spi_read(void);
void mmc_spi_clk(unsigned short n);
void mmc_spi_rate(unsigned short rate);
